routes/web.php
<?php

use App\Http\Controllers\ArticleController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\LikeController;
use App\Http\Controllers\PageController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\UserController;
use App\Models\Article;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

# Home
Route::get('/', HomeController::class)->name('home');

// # Users
Route::get('/users', [UserController::class, 'index'])->name('users.index');
Route::get('/users/{user}', [UserController::class, 'show'])->name('users.show');

# Approvement
Route::controller(ArticleController::class)->middleware('can.write.article')->group(function() {
    # Table
    Route::get('articles/table', [ArticleController::class, 'table'])->name('articles.table');
    # Update Status
    Route::put('articles/{article}/update-status', [ArticleController::class, 'updateStatus'])->name('articles.update-status');
});


# Article Search
Route::get('articles/search', [ArticleController::class, 'search'])->name('articles.search');

# Articles
Route::resource('articles', ArticleController::class);

# Category
Route::resource('categories', CategoryController::class);

# Tags
Route::resource('tags', TagController::class);


Route::middleware('auth')->group(function() {
    # Comments
    Route::controller(CommentController::class)->group(function () {
        Route::post('comments/{article}', 'store')->name('comments.store');
        Route::delete('comments/{comment}', 'destroy')->name('comments.destroy');
    });
    # Likes
    Route::controller(LikeController::class)->group(function() {
        Route::post('like-comment/{comment}', 'likeComment')->name('comments.like');
        Route::post('like-article/{article}', 'likeArticle')->name('articles.like');
    });
});


# Auth
require __DIR__ . '/auth.php';

Route::controller(RoleController::class)->middleware('only.admin')->group(function () {
    Route::post('roles/assign/{user}', 'assign')->name('roles.assign');
});

# Account
Route::controller(UserController::class)->group(function() {
    Route::get('users', 'index')->name('users.index');
    Route::get('/account/edit', 'edit')->name('users.edit');
    Route::put('/account/edit', 'update')->name('users.update');
    Route::get('/{user}', [UserController::class, 'show'])->name('users.show');
});

# Change Password
Route::controller(ChangePasswordController::class)->middleware('auth')->group(function () {
    Route::get('account/password-edit', 'edit')->name('change-password.edit');
    Route::put('account/password-edit', 'update')->name('change-password.update');
});

// # Users
Route::get('/{user}', [UserController::class, 'show'])->name('user.show');

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;
    protected $table = 'categories';
    protected $fillable = ['name', 'slug'];

    # get route key name
    public function getRouteKeyName()
    {
        return 'slug';
    }

    # published article
    public function scopePublished($query)
    {
        return $query->where('status', \App\Enums\ArticleStatus::PUBLISHED);
    }

    # relation table
    public function articles() {
        return $this->hasMany(Article::class);
    }
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CategoryRequest;
use App\Models\Category;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;

class CategoryController extends Controller
{
    # method __construct for middleware
    public function __construct()
    {
        return $this->middleware(['only.admin', 'auth', 'verified', 'preventBackHistory'])->except('show');
    }

    # show all data categories
    public function index()
    {
        # action show all data categories
        $categories = Category::query()->latest()->paginate(10);

        # return view
        return view('categories.index', compact('categories'));
    }

    # view create category
    public function create()
    {
        $category = New Category();
        return view('categories.create', compact('category'));
    }

    # process create category
    public function store(CategoryRequest $request)
    {
        # action create category
        Category::create([
            'name' => $name = $request->name,
            'slug' => str($name . ' ' . str()->random(3))->slug(),
        ]);

        # redirect
        return to_route('categories.index')->with('success', 'Data category has been created ');
    }

    # show articles by category
    public function show(Category $category)
    {
        // $articles = $category->articles()->paginate(9);
        # get data articles by category when article has been published
        $articles = $category->articles()->published()->latest()->paginate(15);

        # return view
        return view('categories.show', compact('category', 'articles'));
    }

    # view edit category
    public function edit(Category $category)
    {
        # return view
        return view('categories.edit', compact('category'));
    }

    # process update category
    public function update(CategoryRequest $request, Category $category)
    {
        # action update category
        $category->update([
            'name' => $name = $request->name,
            'slug' => str($name . ' ' . str()->random(3))->slug(),
        ]);

        # redirect
        return to_route('categories.index')->with('success', 'Data category has been updated ');
    }

    # process delete category
    public function destroy(Category $category)
    {
        # action delete category
        $category->delete();

        # redirect
        return to_route('categories.index')->with('success', 'Data category has been deleted ');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use App\Enums\ArticleStatus;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\View\Component;

class AppLayout extends Component
{
    public $title;
    /**
     * Create a new component instance.
     *
     * @return void
     */

    public function __construct($title = 'Default Title')
    {
        $this->title = $title;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $categories = \App\Models\Category::query()
        ->select('name', 'slug')
        ->whereHas('articles', function(Builder $query) {
            $query->where('status', ArticleStatus::PUBLISHED);
        })
        ->get();
        return view('layouts.app', compact('categories'));
    }
}

resources/views/categories/create.blade.php
<x-app-layout title="Create New Category - Article">
  <div class="container">
    <div class="row">
      <div class="col-md-8">
        <x-card title="New" subtitle="Create new category" class="shadow">
          {{-- form create category --}}
          <form action="{{ route('categories.store') }}" method="POST">
            @include('categories.form', ['submit' => 'Create'])
          </form>
        </x-card>
      </div>

      {{-- table of categories --}}
      <div class="col-md-4">
        <a class="btn btn-primary w-100" href="{{ route('categories.index') }}">
          Table of categories
        </a>
      </div>

    </div>
  </div>
</x-app-layout>

resources/views/categories/edit.blade.php
<x-app-layout title="Edit Category: {{ $category->name }} - GreenK Article">
  <div class="container">
    <div class="row">
      <div class="col-md-8">
        <x-card title="Edit" class="shadow">
          {{-- form edit article category --}}
          <form action="{{ route('categories.update', $category) }}" method='POST'>
            @method('PUT')
            @include('categories.form', ['submit' => 'Update'])
          </form>
        </x-card>
      </div>

      <div class="col-md-4">
        {{-- Table of Categories --}}
        <a class="btn btn-primary w-100" href="{{ route('categories.index') }}">
          Table of categories
        </a>

        {{-- Delete Button Modal --}}
        <button type="button" class="btn btn-danger w-100 mt-2" data-bs-toggle="modal" data-bs-target="#exampleModal">
          Delete
        </button>
        <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
          <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Category: {{ $category->name }}</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
              </div>
              <div class="modal-body">
                <p class="text-muted text-center">
                  Are you really sure you want to delete it?
                </p>
                <div class="d-flex align-items-center gap-2 justify-content-center">
                  <form action="{{ route('categories.destroy', $category) }}" method="POST">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger btn-md">Yes</button>
                    <button type="button" class="btn btn-secondary btn-md" data-bs-dismiss="modal" aria-label="Close">No</button>
                  </form>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</x-app-layout>

resources/views/categories/form.blade.php
@csrf
{{-- category name --}}
<div class="mb-4">
  <label for="name" class="form-label">Category Name</label>
  <input type="text" name="name" id="name" class="form-control @error('name') is-invalid @enderror" value="{{ old('name', $category->name) }}">
  @error('name')
  <div class="invalid-feedback">{{ $message }}</div>
  @enderror
</div>

{{-- button submit --}}
<button type="submit" class="btn btn-primary btn-md">{{ $submit }}</button>

resources/views/categories/index.blade.php
<x-app-layout title="Table of Categories - GreenK Article">
  @push('styles')
  @include('components.toast.alerts-css')
  @endpush
  <div class="container">
    <div class="row d-flex align-items-center justify-content-center">
      <div class="col-md-8">
        <div class="d-flex justify-content-end mb-2">
          <a href="{{ route('categories.create') }}" class="btn btn-primary">New</a>
        </div>
        <x-card title="Categories" subtitle="Table of categories" class="shadow">
          {{-- Table of Categories --}}
          <table class="table table-striped">
            <thead>
              <tr>
                <th>#</th>
                <th>Category Name</th>
                <th>Slug</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody>
              @forelse($categories as $index => $category)
              <tr>
                <td>{{ $index + 1 }}</td>
                <td>{{ $category['name'] }}</td>
                <td>{{ $category['slug'] }}</td>
                <td>
                  <a href="{{ route('categories.edit', $category) }}" class="btn btn-warning btn-sm">
                    Edit
                  </a>
                </td>
              </tr>
              @empty
              <tr>
                <td colspan="4">Category does not exist</td>
              </tr>
              @endforelse
            </tbody>
          </table>
        </x-card>
        <div class="mt-2">{{ $categories->links() }}</div>
      </div>
    </div>
  </div>
  @push('scripts')
  @include('components.toast.alerts-js')
  @endpush
</x-app-layout>

resources/views/categories/show.blade.php
<x-app-layout title="{{ $category->name }} Category - GreenK Article">
    <x-header :title="$category->name" subtitle="This page will show all articles by {{ $category->name }} category" />
    <div class="container">
        <x-articles :articles="$articles" />
    </div>
</x-app-layout>